﻿using System;
using System.Threading;

namespace WaitHandles
{
    class Program
    {

        static bool isNew = false;
        static EventWaitHandle waitingGate = new EventWaitHandle(false, EventResetMode.AutoReset, "waitingGate", out isNew);
        static void WaitingGateThread()
        {
            Console.WriteLine("I'm waiting ....");
            waitingGate.WaitOne();
            Console.WriteLine("... and I lived to see it");
        }

        static void UnlockingGateThread()
        {
            Console.WriteLine("I'm opening the gate ....");
            waitingGate.Set();
            Console.WriteLine("... and I opened it");
        }
        static void Main(string[] args)
        {
            //In this example we need 2 process so run it with ctrl+F5 two times
            if (isNew)
            {
                Console.WriteLine("The thread starts from the process that WaitHandle created");
                Thread thread = new Thread(WaitingGateThread);
                thread.Name = "waitingGate";
                thread.Start();
            }
            else
            {
                Console.WriteLine("The thread starts from the process that didn't WaitHandle created");
                Thread thread = new Thread(UnlockingGateThread);
                thread.Name = "openingGate";
                thread.Start();
            }
            
        }
    }
}
